<template>
	<div class="courses">
		<div class="actions">
			<span class="button is-primary" @click="modalShow = true">Add Course</span>
		</div>

		<table class="table">
			<thead>
				<tr>
					<th>ID</th>
					<th>Name</th>
					<th>Description</th>
					<th>Groups</th>
					<th></th>
				</tr>
			</thead>
			<tbody>
				<tr v-for="course in courses">
					<td>{{ course.courseId }}</td>
					<td>{{ course.name }}</td>
					<td>{{ course.description }}</td>
					<td>{{ course.groups.length }}</td>
					<th><span class="icon is-small"><i class="fa fa-ban"></i></span></th>
				</tr>
			</tbody>
		</table>

		<transition name="fade">
			<div class="modal is-active" v-if="modalShow">
				<div class="modal-background" @click="modalShow = false"></div>
				<div class="modal-content" style="width: 400px">
					<div class="box">
						<label class="label">Name</label>
						<p class="control">
							<input class="input" type="text" v-model="course.name">
						</p>
						<label class="label">Description</label>
						<p class="control">
							<input class="input" type="text" v-model="course.description">
						</p>
					<!-- <label class="label">Confirm Password</label>
					<p class="control">
						<input class="input" type="password" placeholder="●●●●●●●">
					</p> -->
					<hr>
					<p class="control">
						<button class="button is-primary" @click="addCourse">Add Course</button>
						<button class="button is-default" @click="modalShow = false">Cancel</button>
					</p>
				</div>
			</div>
			<button class="modal-close" @click="modalShow = false"></button>
		</div>
	</transition>


	<div class="modal is-active" v-if="deleteConfirmShow">
		<div class="modal-background" @click="deleteConfirmShow = false"></div>
		<div class="modal-content">

			<article class="message">
				<div class="message-header">
					Are you sure?
				</div>
				<div class="message-body">
					<button class="button is-danger" @click="deleteUser(deleteId)">Yes</button>
					<button class="button" @click="deleteConfirmShow = false">Cancel</button>
				</div>
			</article>

		</div>
		<button class="modal-close"></button>
	</div>




</div>
</template>

<script>
	import auth from '../../utils/auth'
	import course from '../../utils/course'

	export default {
		name: 'course',
		data() {
			return {
				course: {},
				courses: [],
				modalShow: false,
				deleteConfirmShow: false,
				deleteId: ''
			}
		},
		methods: {
			addCourse() {
				var newCourse = {
					name:  this.course.name,
					description: this.course.description
				}

				course.newCourse(this, newCourse)
				.then((course) => this.courses.push(course))

				this.modalShow = false
			},
			deleteConfirm(id) {
				this.deleteConfirmShow = true
				this.deleteId = id
			},

			deleteUser(id) {
				user.deleteUser(this, id)
				this.deleteConfirmShow = false
			}
		},
		mounted() {
			let self = this
			course.getAllCourses(this)
			// .then((res) => console.log(res))
			.then((courses) => self.courses = courses)
			.catch((err) => console.error(err))

		}
	}
</script>

<style>
	.fade-enter-active, .fade-leave-active {
  transition: opacity .2s
}
.fade-enter, .fade-leave-active {
  opacity: 0
}
</style>
